/* this sketch uses libraries:
* https://github.com/AlexisTM/ASCIIDic
* https://github.com/AlexisTM/NX7Seg
* need to download zip and install
*/

#include <ASCIIDic.h>
#include <NX7Seg.h>

#define LATCH_DIO 4 //rclk
#define CLK_DIO 7   // sclk
#define DATA_DIO 8  // dio

nx7seg my4x7seg = nx7seg(LATCH_DIO,CLK_DIO,DATA_DIO);
 
void setup_7seg (){
  /* Set DIO pins to outputs */
  pinMode(LATCH_DIO,OUTPUT);
  pinMode(CLK_DIO,OUTPUT);
  pinMode(DATA_DIO,OUTPUT);
}
 
/*
 * library supports also showing float(writeFloat) and INT(writeInt)
 * but it cannot reverse order of digits
 * and I had item that is reversed
 * .
 * This function uses the library function of printing chars
 * in order to reverse order of digits
 * 
 * it is intended to show integers
 */
void showDigits(int num){
    char data[5]="    ";
    data[0]=char('0'+num%10);
    if(num >= 10){
      data[1]=char('0'+floor(num/10) %10);
    }
    if(num >= 100){
      data[2]=char('0'+floor(num/100) %10);
    }
    if(num >= 1000){
      data[3]=char('0'+floor(num/1000) %10);
    }
    my4x7seg.write(data,4);
    my4x7seg.refresh(1500);
}
void displayOFF(){
    char data[5]="    ";
    my4x7seg.write(data,4);
    my4x7seg.refresh(1500);
}

