/*
 * this tab handles a code of 2 buttons
 *  
 *  It enables a small space coding element
 */

const int kodan_pbtn_Red=5;
const int kodan_pbtn_Green=6;
const int kodan_pinSpkr=2;

#define KODAN_LEN 4 // how many presses are in the code. check of correctnes is after KODAN_LEN presses were made
char kodan_hist[KODAN_LEN]=""; // the sequence so far
char kodan_code[KODAN_LEN]="RRGR"; // the correct sequence. R=red G=green
byte kodan_index=0;

void setup_kodan(){
  pinMode(kodan_pinSpkr, OUTPUT); 
  pinMode(kodan_pbtn_Red, INPUT); 
  pinMode(kodan_pbtn_Green, INPUT); 
    
  digitalWrite(kodan_pinSpkr, LOW); 

}
bool loop_kodan(){
  bool ok=false;
  if(digitalRead(kodan_pbtn_Red) == HIGH){
    ok=kodan_pressed('R');
  }
  if(digitalRead(kodan_pbtn_Green) == HIGH){
    ok=kodan_pressed('G');
  }
  return ok;
}
bool kodan_check(){
  bool ret=false;

  bool flag=true;
  for(byte k=0;k<KODAN_LEN;k++){
    if(kodan_hist[k] != kodan_code[k]){
      flag=false;
      break;
    }
  }

  if(flag){
    kodan_beep_ok();
    ret=true;
  }
  else {
    kodan_beep_wrong();
  }
  return ret;
}
bool kodan_pressed(char btn_id){
  bool ret=false;
  kodan_beep();
  kodan_hist[kodan_index]=btn_id;
//  Serial.print(kodan_hist);
  debug(String(kodan_hist));
  debug("   index=");
  debug(String(kodan_index));
  debug("   btn_id=");
  debug(String(btn_id));
  debugln(" !");
  kodan_index++;
  if(kodan_index >= KODAN_LEN){
    ret=kodan_check();
    for(byte k=0;k<KODAN_LEN;k++){
      kodan_hist[k]=' ';
    }
    kodan_index=0;
  }
  return ret;
}
void kodan_beep_ok(){
  digitalWrite(kodan_pinSpkr, HIGH); 
  delay(100); 
  digitalWrite(kodan_pinSpkr, LOW); 
  delay(100); 
  digitalWrite(kodan_pinSpkr, HIGH); 
  delay(100); 
  digitalWrite(kodan_pinSpkr, LOW); 
}
void kodan_beep_wrong(){
  digitalWrite(kodan_pinSpkr, HIGH); 
  delay(200); 
  digitalWrite(kodan_pinSpkr, LOW); 
}
void kodan_beep(){
  digitalWrite(kodan_pinSpkr, HIGH); 
  delay(50); 
  digitalWrite(kodan_pinSpkr, LOW); 
}

