/*
 * this code handles a motion detection with PIR
 * which is actually just a digital input pin
 */

 const int motionPin = 3;

#define MOTION_NONE       1
#define MOTION_DETECTED   2

byte currect_motion_state;


 void setup_motion() {
  pinMode(motionPin, INPUT); // Sets the trigPin as an Output

  currect_motion_state=MOTION_NONE;
}
bool loop_motion() {
  bool ret=false;

  /*
   * the following code will give one true for a whole movement
   * the true is at the BEGINNING of the motion detection
   */
  if(digitalRead(motionPin) == HIGH){ // has motion detection
    debugln("motion");
    if(currect_motion_state == MOTION_NONE){ // started to detect motion
      currect_motion_state=MOTION_DETECTED;
      ret=true;
    }
  }
  else { // no motion
    currect_motion_state=MOTION_NONE;    
  }
  return ret;
}

